#include <cstdio>
#include <cstdlib>
#include <queue>
#include <cstring>
#include <string>

using namespace std;

void gen(string s, queue<int> num, queue<char> op, bool flag = true) {
	if (num.empty() && op.empty()) {
		printf("%s\n", s.c_str());
	}
	if (!num.empty()) {
		char buf[4];
		sprintf(buf,"%d",num.front());
		num.pop();
		gen(s+buf,num,op, !flag);
	} 
	if (!op.empty()) {
		char c = op.front();
		op.pop();
		gen(s+c,num,op,flag);
	}
	
}

bool solve() {
	
	char buffer[512];
	memset (buffer, 0, sizeof(buffer));
	
	queue<int> num;
	queue<char> op;
	
	fgets(buffer, sizeof(buffer)-1, stdin);
	if (buffer[0] == 'E') return false;
	char *c = buffer;
	int n = 0;
	while (*c) {
		if (*c == '+') {
			num.push(n);
			n = 0;
			op.push('+');
		}
		else if (*c == '*') {
			num.push(n);
			n = 0;
			op.push('*');
		}
		else if (*c >= '0' && *c <= '9') {
			n *= 10;
			n += (*c)-'0';
		}
		else break;
		c++;
	}
	num.push(n);

	gen("", num, op);
	

	return false;
}

int main(int, char**) {
	while(solve());
	return 0;
}

